NPE in synonym DetailsViewer for synonyms without accepted taxon
Description

if a synonym has no accepted taxon an exception appears.
in DetailsViewerE4.createTaxonSections():

Taxon acceptedTaxon = null;
if (taxonBase instanceof Taxon) {

acceptedTaxon = (Taxon)taxonBase;
lelse{
acceptedTaxon = ((Synonym)taxonBase) .getAcceptedTaxon();
}
Set<TaxonNode> nodes = acceptedTaxon.getTaxonNodes () ;

// check for subtree permissions as well.
if (hasPermission) {
for (TaxonNode node: nodes) {
hasPermission &= CdmStore.currentAuthentiationHasPermission (node, requiredCrud);
if ('hasPermission) {
//check whether there are explicit TaxonNode rights
boolean taxonnodePermissionExists = false;
Collection<? extends GrantedAuthority> authorities = CdmStore.
getCurrentAuthentiation () .getAuthorities();
for (GrantedAuthority grantedAuthority: authorities) {
if (grantedAuthority.getAuthority () .startsWith ("TAXONNODE")) {
taxonnodePermissionExists = true;

}
if (!taxonnodePermissionExists) {
hasPermission = true;

Das sollte abgefangen werden. Allerdings ist die Frage, wie wir dann mit der Permission umgehen (nur fiir diese wird ja das
akzeptierte Taxon benétigt.

Da es sich um einen sehr groBen Ausnahmefall handelt, der aber vorkommen kann (auch im Taxon Bulkeditor kann ich Synonyme
ohne akzeptiertes Taxon erzeugen), fande ich es nicht schlimm dort einfach zu sagen, wenn ein reines Synonym ohne acc vorliegt,
ist der Subtree Filter unrelevant und man bekommt die Permission.

Aber vielleicht habt ihr ja eine bessere Idee. Ich hab da gerade nicht die Zeit driiber nachzudenken.

Related issues:
Copied to EDIT - bug #9083: Improve authorization handling in synonym details... New

Associated revisions

Revision cd5fdc98 - 05/29/2020 11:09 AM - Andreas Miiller

fix #8849 fix NPE for synonyms without accepted taxon in details view and some code cleaning

History

#1 - 02/18/2020 01:11 PM - Katja Luther

- Description updated
#2 - 03/10/2020 10:02 AM - Katja Luther

- Target version changed from Release 5.13 to Release 5.14

move to 5.14

#3 - 03/31/2020 11:26 AM - Katja Luther

- Target version changed from Release 5.14 to Release 5.15

#4 - 04/22/2020 10:23 AM - Katja Luther

- Target version changed from Release 5.15 to Release 5.18

#5 - 05/29/2020 11:10 AM - Andreas Miiller
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset taxeditor|cd5fdc98f90ec4d26348a785e4c7036914428f0.

#6 - 05/29/2020 11:14 AM - Andreas Miiller
- Assignee changed from Katja Luther to Andreas Kohlbecker
- Priority changed from New to Highest

- Target version changed from Release 5.18 to Release 5.15

| solved the NPE now in a way that synonyms without accepted taxon are not checked for subtree permission (as they simply are not part of any
subtree).

Andreas K., can you please check if this is correct in terms of permission concepts and then pass the ticket to KL for reviewing the TaxEditor code?

#7 - 06/17/2020 04:42 PM - Andreas Kohlbecker
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Kohlbecker to Andreas Miller

Generally for permission checks the class CdmUserHelper should be used which provides a couple of methods like userHasPermission(CdmBase
entity, Object... args). String comparison is not always save as you may miss the rules implemented into by specific voters in
CdmPermissionVoter.furtherVotingDescisions(CdmAuthority CdmAuthority, TargetEntityStates targetEntityStates, Collection<ConfigAttribute>
attributes, ValidationResult validationResult).

Instead of using the string TAXONNODE it would be better to use PermissionClass. TAXONNODE instead.

Now to the logic. | think it is correct to only do the second step check for TaxonNode permissions if there is an accepted taxon with TaxonNodes at all.
Otherwise the operation should be granted.

Apart from the above critics, code looks good but should be put into the TaxonBaseVoter as furtherVotingDescisions() implementation. As this can be
breaking things we should do this only after the release. It should not be forgotten though as it is crucial to have all permission deccission logic at a
central place.

One last comment on the CdmStore.currentAuthentiationHasPermission(...) methods: These should also use the CdmUserHelper internally or should
be replaced by calls to the according CdmUserHelper methods.

#8 - 06/17/2020 05:29 PM - Andreas Miiller
Good points.

| suggest to split the ticket. The NPE is fixed so this ticket can be closed.
The improved handling for authorization should be moved to a new ticket with high priority in 5.16.

Ok?

#9 - 06/19/2020 08:37 AM - Andreas Mdiller
- Copied to bug #9083: Improve authorization handling in synonym details view (and generally) added

#10 - 06/19/2020 08:38 AM - Andreas Miiller
- Status changed from Feedback to Closed
- % Done changed from 50 to 100
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/taxeditor/revisions/cd5fdc98f90ec4d26348a785e4c70369144f28f0

Andreas Milller wrote:
Good points.

| suggest to split the ticket. The NPE is fixed so this ticket can be closed.
The improved handling for authorization should be moved to a new ticket with high priority in 5.16.

Ok?

As nobody voted against splitting | do this. New ticket is #8903
https://dev.e-taxonomy.eu/redmine/issues/8903
